# MAIN IMPORTS ================================================================================================================================================ #
import psyco
psyco.full()
import es
import popuplib
import playerlib
# ============================================================================================================================================================= #

# * SAM IMPORTS
func = es.import_addon('sam/functions')

# * VARIABLES

bases  = ['manager','pcontrol','addons','settings']
addons = {}

# ============================================================================================================================================================= #
# ========================================================================== LOAD ============================================================================= #
# ============================================================================================================================================================= #
def load():
	### Load Modules ###
	for item in bases: es.load('sam/base/%s' % item)

# ============================================================================================================================================================= #
# ========================================================================= UNLOAD ============================================================================ #
# ============================================================================================================================================================= #
def unload():
	### Unloads ###
	for item in bases: es.unload('sam/base/%s' % item)

	### Popups ###
	func.popupDelete('mainPage')

# ============================================================================================================================================================= #
# ======================================================================= CMD BLOCKS ========================================================================== #
# ============================================================================================================================================================= #
def menuCMD(userid):
	admins = es.import_addon('sam/base/manager')
	if admins.checkDB():
		if admins.isAdmin(es.getplayersteamid(userid)): displayMenu(userid)
		else: func.hudhint(userid, func.lang_admins('no_access'), func.admins_hudtag)
	else: admins.firstAdmin(userid)

# ============================================================================================================================================================= #
# ======================================================================= MAIN BLOCKS ========================================================================= #
# ============================================================================================================================================================= #
def displayMenu(userid, send=1):
	func.popupDelete('mainPage')
	popup = popuplib.easymenu('mainPage', None, mainPageChoice)
	popup.c_beginsep = func.pline
	if not func.cloud['newversion'] == 0: popup.c_pagesep = 'UPDATE SYSTEM:\n%s\n%s\n%s' % (func.pline,func.lang_base('outdated_menu', {'newversion':func.cloud['newversion']}),func.pline)
	else: popup.c_pagesep = func.pline
	popup.settitle('%s | SAM %s\n \n :: %s ' % (func.menutitle, es.ServerVar(func.version),func.lang_titles('base_mainPage_title')))
	popup.recache(userid)
	popup.addoption('pcontrol', func.lang_titles('pcontrol_name'))
	if len(addons) > 0:
		for x in addons:
			if int(es.ServerVar('sam_' + addons[x])) == 1: popup.addoption(addons[x], func.lang_titles('addons_%s_name' % addons[x]))
	popup.addoption('addons', func.lang_titles('addons_name'))
	popup.addoption('manager', func.lang_titles('manager_name'))
	if send == 1: popup.send(userid)

# :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def mainPageChoice(userid, choice, popup):
	admins = es.import_addon('sam/base/manager')
	if choice in bases:
		block = es.import_addon('sam/base/%s' % (choice))
		if choice == 'pcontrol': block.modulePopup(userid)
		elif choice == 'addons':
			if admins.checkAccess(es.getplayersteamid(userid), 'Addons Manager'): block.modulePopup(userid)
			else: displayMenu(userid)
		elif choice == 'manager':
			if admins.checkAccess(es.getplayersteamid(userid), 'Admins Manager'): block.modulePopup(userid)
			else: displayMenu(userid)
	else:
		if int(es.ServerVar('sam_%s' % choice)) == 1:
			block = es.import_addon('sam/base/addons/%s' % choice)
			block.addonPopup(userid)
		else:
			func.hudhint(userid, func.lang_addons('addon_is_disabled'))
			displayMenu(userid)

# ============================================================================================================================================================= #