# MAIN IMPORTS =============================================================================================================================================== #
import psyco
psyco.full()
import es
import os
import keyvalues
import playerlib
import popuplib
import langlib
import cmdlib
# ============================================================================================================================================================ #

# * SAM IMPORTS
func   = es.import_addon('sam/functions')

# * VARIABLES
db          = 'sam_admins'
dbfile      = 'cstrike/cfg/sam/databases/es_%s_db.txt' % db
groups_path = 'sam/base/manager/groups'
temp        = {'toggle':'yes'}
adv         = ['Respawn','Noclip','Godmode','Freeze','Jetpack','Blind','Firework','Slap','Set Health','Give Cash','Invisibility','Crazy Drug']
access = [
			'Admins Manager','Addons Manager','Kick',
			'Ban Level 1','Ban Level 2','Unban',
			'Move Players','Slay','Mute',
			'Server Commands','Remote RCON','Advance Control',
			'Admin Chat','Votes','Server Restart','Play Sounds'
		 ]

# ============================================================================================================================================================= #
# ========================================================================== LOAD ============================================================================= #
# ============================================================================================================================================================= #
def load():
	### Load Keygroups ###
	if checkDB(): es.keygroupload(db, func.dbfiles)

	### CMDS ###
	cmdlib.registerSayCommand('!addadmin', addAdminCMD, 'SAM')
	cmdlib.registerClientCommand('sam_addadmin', addAdminCMD, 'SAM')

	### Load Groups ###
	es.load(groups_path)
	global groups
	groups = es.import_addon(groups_path)

	### Update Admins ###
	if checkDB():
		for ply in playerlib.getPlayerList('#human'):
			if isAdmin(ply.steamid): update(ply.steamid)

# ============================================================================================================================================================ #
# ========================================================================= UNLOAD =========================================================================== #
# ============================================================================================================================================================ #
def unload():
	### Deletes ###
	es.keygroupdelete(db)

	### CMDS ###
	cmdlib.unregisterSayCommand('!addadmin')
	cmdlib.unregisterClientCommand('sam_addadmin')

	### Unload Groups ###
	es.unload(groups_path)

	### Popups ###
	func.popupDelete('firstAdmin')
	func.popupDelete('manager')
	func.popupDelete('manager_getTarget')
	func.popupDelete('manager_edit')
	func.popupDelete('manager_getGroup')

# ============================================================================================================================================================= #
# ======================================================================= CMD BLOCKS ========================================================================== #
# ============================================================================================================================================================= #
def addAdminCMD(userid, args):
	if isAdmin(es.getplayersteamid(userid)):
		if checkAccess(es.getplayersteamid(userid), 'Admins Manager'):
			if args:
				try:
					string = ''.join(args)
					if string.startswith('STEAM_'):
						if not isAdmin(string):
							add(string)
							if es.exists('userid', es.getuserid(string)): update(string)
							editChoice(userid, string, None)
						else: func.hudhint(userid, func.lang_admins('is_admin', {'admin':string}), func.admins_hudtag)
					elif es.exists('userid', es.getuserid(string)):
						target = playerlib.getPlayer(es.getuserid(string))
						if not isAdmin(target.steamid):
							add(target.steamid)
							editChoice(userid, target.steamid, None)
						else: func.hudhint(userid, func.lang_admins('is_admin', {'admin':target.name}), func.admins_hudtag)
				except: func.tell(userid, '#red%s' % func.lang_admins('cmd_example'), func.adminstag)
			else: func.tell(userid, '#red%s' % func.lang_admins('cmd_example'), func.adminstag)
		else: managerChoice(userid, 1, None)
	
# ============================================================================================================================================================ #
# ======================================================================= MAIN BLOCKS ======================================================================== #
# ============================================================================================================================================================ #
def modulePopup(userid, send=1):
	func.popupDelete('manager')
	popup = popuplib.create('manager')
	popup.addline('%s | SAM %s' % (func.menutitle, es.ServerVar(func.version)))
	popup.addline('\n \n :: %s' % func.lang_titles('manager_name'))
	popup.addline(func.pline)
	popup.addline('->1. %s' % func.lang_admins('add'))
	popup.addline('->2. %s' % func.lang_admins('remove'))
	popup.addline('->3. %s' % func.lang_admins('edit_admin'))
	popup.addline(' ')
	popup.addline(' :: %s' % func.lang_word('groups'))
	popup.addline(func.pline)
	popup.addline('->4. %s' % func.lang_groups('create_group'))
	popup.addline('->5. %s' % func.lang_groups('delete_group'))
	popup.addline('->6. %s' % func.lang_groups('edit_group'))
	popup.addline(' ')
	popup.addline(func.pline)
	popup.addline('->8. %s' % func.lang_word('back'))
	popup.addline('0. %s' % func.lang_word('cancel'))
	popup.submenu(8, 'mainPage')
	popup.menuselect = managerChoice
	if send == 1: popup.send(userid)

# ------------------------------------------------------------------------------------------------------------------------------------------------------------ #
def managerChoice(userid, choice, popup):
	func.popupDelete('manager_getTarget')
	if choice in range(1,4):
		if choice == 1:   popup = popuplib.easymenu('manager_getTarget', None, addChoice)
		elif choice == 2: popup = popuplib.easymenu('manager_getTarget', None, remChoice)
		elif choice == 3: popup = popuplib.easymenu('manager_getTarget', None, editChoice)
		popup.c_beginsep = func.pline
		popup.c_pagesep  = func.pline
		popup.settitle('%s | SAM %s\n \n :: %s ' % (func.menutitle, es.ServerVar(func.version), func.lang_titles('manager_name')))
		if choice == 1:
			popup.setdescription('\n # %s' % func.lang_titles('choose_player'))
			for player in playerlib.getPlayerList('#human'): popup.addoption(player, player.name)
		elif choice > 1:
			popup.setdescription('\n # %s' % func.lang_titles('choose_admin'))
			for admin in keyvalues.getKeyGroup(db): popup.addoption(admin, es.keygetvalue(db, admin, 'name'))
		popup.submenu(10, 'manager')
		popup.send(userid)
	elif choice in range(4,7):
		if choice == 4: groups.startFilter(userid)
		if choice in [5,6]:
			if groups.checkDB() and es.exists('keygroup', groups.db):
				if len(list(keyvalues.getKeyGroup(groups.db))) > 0: groups.chooseGroup(userid, choice)
				else:
					func.hudhint(userid, func.lang_groups('theres_no_groups'), func.admins_hudtag)
					modulePopup(userid)
			else:
				func.hudhint(userid, func.lang_groups('theres_no_groups'), func.admins_hudtag)
				modulePopup(userid)
	elif choice < 8: modulePopup(userid)

# :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def addChoice(userid, choice, popup):
	target = playerlib.getPlayer(choice)
	if not isAdmin(target.steamid):
		add(target.steamid)
		update(target)
		editChoice(userid, target.steamid, popup)
		func.hudhint(userid, func.lang_admins('admin_added', {'target':target.name}), func.admins_hudtag)
	else:
		func.hudhint(userid, func.lang_admins('is_admin', {'admin':target.name}), func.admins_hudtag)
		modulePopup(userid)

# :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def remChoice(userid, choice, popup):
	if isAdmin(choice):
		admin = getAdmin(choice)
		func.hudhint(userid, func.lang_admins('admin_removed', {'target':admin['name']}), func.admins_hudtag)
		remove(userid, choice)
	else: func.tell(userid, func.lang_admins('not_an_admin'), func.adminstag)
	modulePopup(userid)

# :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def editChoice(userid, choice, popup, page = None):
	if not str(choice).startswith('STEAM'): choice = es.getplayersteamid(choice)
	admin = getAdmin(choice)
	es.set('sam_%s_setimmunity' % userid, 0)
	es.set('sam_%s_setgroup' % userid, 0)
	if admin:
		func.popupDelete('manager_edit')
		popup = popuplib.easymenu('manager_edit', None, editAdmin_Choice)
		popup.c_beginsep = func.pline + '\n# %s: %s\n# ID: %s\n ' % (func.lang_word('name'),admin['name'], choice)
		popup.c_pagesep  = func.pline
		popup.settitle('%s | SAM %s\n \n :: %s ' % (func.menutitle, es.ServerVar(func.version), func.lang_admins('edit_admin')))
		popup.addoption({'item':'toggle','admin':admin}, func.lang_admins('toggle_all', {'state':func.lang_word(temp['toggle'])}))
		popup.addoption({'item':'group','admin':admin}, '%s: %s' % (func.lang_word('group'), admin['group']))
		popup.addoption({'item':'immunity','admin':admin}, '%s: %s' % (func.lang_word('immunity'), admin['immunity']))
		for item in access: popup.addoption({'item':item,'admin':admin}, '%s: %s' % (item, func.lang_word(admin[item])))
		popup.submenu(10, 'manager')
		if page != None: popup.sendPage(userid, page)
		else: popup.send(userid)
	else:
		func.tell(userid, func.lang_admins('not_an_admin'))
		modulePopup(userid)

# ------------------------------------------------------------------------------------------------------------------------------------------------------------ #
def editAdmin_Choice(userid, choice, popup):
	admin = choice['admin']
	data  = access
	if choice['item'] not in ('toggle','immunity','group'): page = func.getPage(data.index(choice['item']) + 3, 7)
	else: page = 1
	im = es.ServerVar('sam_%s_setimmunity' % (userid))
	if int(im) == 0:
		if choice['item'] == 'toggle':
			for item in data: es.keysetvalue(db, admin['steamid'], item, temp['toggle'])
			es.keygroupsave(db, 'sam/databases')
			if temp['toggle'] == 'yes': temp['toggle'] = 'no'
			else: temp['toggle'] = 'yes'
			editChoice(userid, admin['steamid'], popup, page)
		elif choice['item'] == 'immunity':
			im.set(1)
			temp[userid] = admin['steamid']
			es.addons.registerSayFilter(setFilter)
			func.tell(userid, func.lang_admins('immunity_get_value'), func.adminstag)
		elif choice['item'] == 'group':
			if groups.checkDB() and es.exists('keygroup', groups.db):
				kg = keyvalues.getKeyGroup(groups.db)
				if len(list(kg)) > 0:
					func.popupDelete('manager_getGroup')
					popup = popuplib.easymenu('manager_getGroup', None, setAdminGroup)
					popup.c_beginsep = func.pline
					popup.c_pagesep  = func.pline
					popup.settitle('%s | SAM %s\n \n :: %s ' % (func.menutitle, es.ServerVar(func.version), func.lang_titles('manager_groups_name')))
					popup.setdescription('\n# %s' % func.lang_titles('manager_groups_desc'))
					if not admin['group'] == 'None': popup.addoption({'admin':admin,'group':'None'}, func.lang_groups('remove_admin_group'))
					for item in kg: popup.addoption({'admin':admin,'group':item}, es.keygetvalue('sam_groups', item, 'name'))
					popup.submenu(10, 'manager')
					popup.send(userid)
				else:
					func.hudhint(userid, func.lang_groups('theres_no_groups'), func.admins_hudtag)
					editChoice(userid, admin['steamid'], None)
			else:
				func.hudhint(userid, func.lang_groups('theres_no_groups'), func.admins_hudtag)
				editChoice(userid, admin['steamid'], None)
		else:
			if es.keygetvalue(db, admin['steamid'], choice['item']) == 'yes': es.keysetvalue(db, admin['steamid'], choice['item'], 'no')
			elif es.keygetvalue(db, admin['steamid'], choice['item']) == 'no': es.keysetvalue(db, admin['steamid'], choice['item'], 'yes')
			es.keygroupsave(db, 'sam/databases')
			editChoice(userid, admin['steamid'], popup, page)

# ============================================================================================================================================================ #
# ======================================================================== FUNCTIONS ========================================================================= #
# ============================================================================================================================================================ #
def add(target, state='no'):
	string = str(target)
	userid = es.getuserid(target)
	if string.startswith('STEAM_'): admin = {'steamid':string,'name':string}
	else: admin = {'steamid':es.getplayersteamid(userid),'name':es.getplayername(userid)}
	if not es.exists('keygroup', db): es.keygroupcreate(db)
	es.keycreate(db, admin['steamid'])
	es.keysetvalue(db, admin['steamid'], 'name', admin['name'])
	es.keysetvalue(db, admin['steamid'], 'immunity', 0)
	es.keysetvalue(db, admin['steamid'], 'group', 'None')
	for item in access: es.keysetvalue(db, admin['steamid'], item, state)
	es.keygroupsave(db, func.dbfiles)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def remove(userid, target):
	if isAdmin(target):
		if len(list(keyvalues.getKeyGroup(db))) > 1:
			es.keydelete(db, target)
			es.keygroupsave(db, func.dbfiles)
		else: func.hudhint(userid, func.lang_admins('need_one_admin'), func.admins_hudtag)
	else: func.hudhint(userid, func.lang_admins('not_admin'), func.admins_hudtag)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def update(admin):
	admin = playerlib.getPlayer(es.getuserid(admin))
	es.keysetvalue(db, admin.steamid, 'name', admin.name)
	for item in access:
		if not es.exists('keyvalue', db, admin.steamid, item): es.keysetvalue(db, admin.steamid, item, 'yes')
	es.keygroupsave(db, func.dbfiles)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def isAdmin(target):
	if checkDB():
		if es.exists('keygroup', db):
			if es.exists('key', db, target): return True
			else: return False
		else: return False
	else: return False

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def getAdmin(target):
	if isAdmin(target):
		tokens = {'steamid':target}
		for x in (('name','immunity','group'), access):
			for item in x: tokens[item] = es.keygetvalue(db, target, item)
		return tokens
	else: return False

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def checkAccess(target, item):
	admin = getAdmin(target)
	if item in adv: item = 'Advance Control'
	if not admin['group'] == 'None': group = groups.get(admin['group'])
	elif item == 'Ban': group = {'Ban Level 1':'no','Ban Level 2':'no'}
	else: group = {item:'no'}
	if item == 'Ban':
		level = 0
		if admin['Ban Level 1'] == 'yes' or group['Ban Level 1'] == 'yes': level = 1
		if admin['Ban Level 2'] == 'yes' or group['Ban Level 2'] == 'yes': level = 2
		if level > 0: return level
		else:
			func.hudhint(es.getuserid(admin['steamid']), func.lang_admins('no_access'), func.admins_hudtag)
			return False
	elif admin[item] == 'yes' or group[item] == 'yes': return True
	else:
		func.hudhint(es.getuserid(admin['steamid']), func.lang_admins('no_access'), func.admins_hudtag)
		return False

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def checkImmunity(admin, target, notify=1):
	if isAdmin(target) and admin != target:
		admin  = getAdmin(admin)
		target = getAdmin(target)
		### Admin IM
		if admin['group'] != 'None':
			group = groups.get(admin['group'])
			if int(group['immunity']) > int(admin['immunity']): adminIM = int(group['immunity'])
			else: adminIM = int(admin['immunity'])
		else: adminIM = int(admin['immunity'])
		### Target IM
		if target['group'] != 'None':
			group = groups.get(target['group'])
			if int(group['immunity']) > int(target['immunity']): targetIM = int(group['immunity'])
			else: targetIM = int(target['immunity'])
		else: targetIM = int(target['immunity'])
		### Algorithm
		if adminIM > targetIM: return True
		elif adminIM <= targetIM:
			if notify == 1: func.hudhint(es.getuserid(admin['steamid']), func.lang_admins('low_immunity'), func.admins_hudtag)
			return False
	else: return True

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def checkDB():
	if os.path.isfile(dbfile): return True
	else: return False

# ============================================================================================================================================================ #
# ========================================================================= EVENTS =========================================================================== #
# ============================================================================================================================================================ #
def player_activate(ev):
	if checkDB() and isAdmin(ev['es_steamid']): update(ev['es_steamid'])

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def player_changename(ev):
	if checkDB() and isAdmin(ev['es_steamid']): update(ev['es_steamid'])

# ============================================================================================================================================================ #
# ========================================================================= BLOCKS =========================================================================== #
# ============================================================================================================================================================ #
def setIM(): es.addons.registerSayFilter(setFilter)

# :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def setAdminGroup(userid, choice, popup):
	admin = choice['admin']
	es.keysetvalue(db, admin['steamid'], 'group', choice['group'])
	es.keygroupsave(db, 'sam/databases')
	editChoice(userid, admin['steamid'], None)
	if choice['group'] == 'None': func.hudhint(userid, func.lang_groups('removed_admin_group', {'admin':admin['name'],'group':admin['group']}), func.admins_hudtag)
	else: func.hudhint(userid, func.lang_admins('added_group', {'admin':admin['name'],'group':choice['group']}), func.admins_hudtag)

# :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def setFilter(userid, text, teamonly):
	text.strip('"')
	im = es.ServerVar('sam_%s_setimmunity' % (userid))
	if int(im) == 1:
		target = temp[userid]
		if not text == '!cancel':
			try:
				if int(text.strip('"')) in range(0,101):
					im.set(0)
					es.addons.unregisterSayFilter(setFilter)
					es.keysetvalue(db, target, 'immunity', int(text))
					es.keygroupsave(db, 'sam/databases')
					editChoice(userid, target, None)
				else: func.tell(userid, func.lang_admins('immunity_wrong_range'), func.adminstag)
			except: func.tell(userid, func.lang_admins('immunity_wrong_range'), func.adminstag)
		else:
			es.addons.unregisterSayFilter(setFilter)
			editChoice(userid, target, None)
			im.set(0)
			func.hudhint(userid, func.lang_base('op_canceled'), func.server_hudtag)
		return (0, 0, 0)
	else: return (userid, text, teamonly)

# ============================================================================================================================================================ #
# ========================================================================= BLOCKS =========================================================================== #
# ============================================================================================================================================================ #
def firstAdmin(userid):
	target = playerlib.getPlayer(userid)
	func.popupDelete('firstAdmin')
	popup = popuplib.create('firstAdmin')
	popup.addline('%s | SAM %s' % (func.menutitle, es.ServerVar(func.version)))
	popup.addline('\n \n :: %s' % func.lang_titles('manager_name'))
	popup.addline(func.pline + '-' * 15)
	popup.addline(' %s\n' % func.lang_admins('firstAdmin_line1'))
	popup.addline(' %s\n \n' % func.lang_admins('firstAdmin_line2'))
	popup.addline(func.lang_admins('firstAdmin_line3'))
	popup.addline('->1. %s' % func.lang_word('yes'))
	popup.addline('->2. %s' % func.lang_word('no'))
	popup.addline(' ')
	popup.addline(func.pline + '-' * 15)
	popup.addline('0. %s' % func.lang_word('cancel'))
	popup.menuselect = firstPageSelect
	popup.send(userid)

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def firstPageSelect(userid, choice, popup):
	if choice == 1:
		es.set('sayfilter_%s' % (userid), 1)
		es.addons.registerSayFilter(chatFilter)
		func.tell(userid, '#grey%s' % func.lang_admins('rcon_confirmation'), func.adminstag)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def chatFilter(userid, text, teamonly):
	var = es.ServerVar('sayfilter_%s' % (userid))
	if int(var) == 1:
		text = text.strip('"')
		var.set(0)
		if str(text) == es.ServerVar('rcon_password'):
			add(userid, 'yes')
			block = es.import_addon('sam/base')
			block.displayMenu(userid, 0)
			modulePopup(userid, 0)
			editChoice(userid, es.getplayersteamid(userid), None)
		else: func.tell(userid, '#grey%s' % func.lang_admins('invalid_rcon', {'text':str(text)}), func.servertag)
		es.addons.unregisterSayFilter(chatFilter)
		return (0, 0, 0)
	else: return (userid, text, teamonly)

# ============================================================================================================================================================ #